unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, printers, ExtCtrls, FlipReverseRotateLibrary;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Button2: TButton;                                                                                                                                     
    Edit3: TEdit;
    OpenDialog1: TOpenDialog;
    Button3: TButton;
    Button4: TButton;
    Edit4: TEdit;
    Label3: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Edit8: TEdit;
    Label7: TLabel;
    RadioGroup1: TRadioGroup;
    Edit7: TEdit;
    Label6: TLabel;
    Bevel1: TBevel;
    Edit9: TEdit;
    Label8: TLabel;
    RadioGroup2: TRadioGroup;
    Edit10: TEdit;
    Edit11: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    ProgressBar1: TProgressBar;
    Label16: TLabel;
    Edit12: TEdit;
    Edit13: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    CheckBox1: TCheckBox;
    CheckBox3: TCheckBox;
    Label13: TLabel;
    Edit14: TEdit;
    Edit15: TEdit;
    Edit16: TEdit;
    Label14: TLabel;
    Label15: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Edit17: TEdit;
    Label22: TLabel;
    CheckBox2: TCheckBox;
    Edit18: TEdit;
    Edit19: TEdit;
    Label23: TLabel;
    Label24: TLabel;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Image2: TImage;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1                                          : TForm1;
  dfi,dfu,dfini                                  : Text;
  para                                           : Array[1..60] of String;
  pb1,pb2,PStart,geladen,xofs,yofs,zofs          : Integer;
  bmp                                            : TBitmap;
  pixbreit,pixhoch                               : Double;

implementation

{$R *.dfm}

Procedure NegativeBitmapFX(aBitmap: TBitmap);
var
  x, y: integer;
  p: pbytearray;
begin
  aBitmap.PixelFormat := pf24Bit;

  for y := 0 to aBitmap.Height - 1 do
  begin
    p := aBitmap.scanline[y];
    for x := 0 to (aBitmap.Width * 3) - 1 do
      p[x] := 255 - p[x]; // oder: p[x] := not p[x];
  end;
end;

Function GetBmpDPI(Bitmap: TBitmap): LongInt;
var
  Stream: TMemoryStream;
  Data: Word;
  A: Double;
begin
  try
    Result := 0;
    Stream := TMemoryStream.Create;
    Bitmap.SaveToStream(Stream);
    Stream.Position := 38;
    if Stream.Read(Data, 2) = 2 then
    begin
      A := Data;
      Result := Round(A / 39.370079);
    end;
  finally
    Stream.Free;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  tm,fsumc,zeile,datei,DPIorg   : String;
  breit,hoch,DPIdef : Integer;
  hmm,bmm,DPI,DPIR : Double;

// ************* Beginn Bild laden *************** //
begin
  geladen:=1;
  datei:=Edit3.Text;
  bmp:=TBitmap.Create;
  bmp.LoadFromFile(datei);                          // Datei zwingend BMP !!!
  Image1.Picture.Bitmap.Assign(bmp);                // Bild anzeigen
  // *** Wichtig **** Damit im TImage das Bild immer komplett //
  // angezeigt wird, muss die "Eigenschaft" "proportional"    //
  // auf "true" gesetzt werden                                //

  breit:=bmp.Width;
  hoch:=bmp.Height;
  DPIdef:=0;
  DPIR:=GetBmpDPI(bmp);
  Edit4.Text:=FloatToStrF(DPIR, ffFixed, 15, 2);

  Progressbar1.Max:=hoch;

  if RadioGroup1.ItemIndex=0 then DPI:=DPIR;
  if RadioGroup1.ItemIndex=1 then DPI:=DPIR/10;

  if DPI=0 then
     Begin
       DPIdef:=1;
       DPI:=72;
       Edit4.Text:='72  (default)';
     end;

  bmm:=(breit/DPI)*2.54;
  hmm:=(hoch/DPI)*2.54;
  pixbreit:=bmm/breit;
  pixhoch:=hmm/hoch;

  Edit1.Text:=IntToStr(breit);
  Edit2.Text:=IntToStr(hoch);
  Edit5.Text:=FloatToStrF(bmm, ffFixed, 15, 2);    // "DOUBLE" Variable in String mit zwei Nachkommastellen umwandeln
  Edit6.Text:=FloatToStrF(hmm, ffFixed, 15, 2);
  Edit7.Text:=FloatToStrF(pixhoch, ffFixed, 15, 5);

  Application.ProcessMessages;
  NegativeBitmapFX(image1.picture.bitmap);
  image1.Refresh;
  sleep(100);
  Application.ProcessMessages;
  NegativeBitmapFX(image1.picture.bitmap);
  image1.Refresh;

end;
// *************** Ende Hauptprozedur zur Dateiverabeitung *************** //



procedure TForm1.Button2Click(Sender: TObject);
var
  zxxc,zxxp,vh,fsumc,fsumcc,zeile,cr,cg,cb,ca,pospix,posxmm,posymm,zv2,zv1,zv0,GV,GR,GZ   : String;
  lsr,cbreit,choch,lein,laus,belichten,rueckfahrt,GRtmp,GVtmp,GZtmp,imess,zabst : String;
  cxofs,cyofs,czofs,nullp,uxmin,uxmax,uymin,uymax,maxacc,defacc : String;
  zx,zy,px,fr,fg,fb,fsum,breit,hoch,XF,XK,ZXX,code,GVx,GRx,GZx,xst,iz : Integer;
  clpix : TColor;
  inistr : Array [1..20] of String;
  vweg,posxmmd,posymmd,dbreit,dhoch : Double;

begin
//  G-Code ausgeben  //

  cxofs:=Edit15.Text;
  cyofs:=Edit16.Text;
  czofs:=Edit14.Text;
  nullp:='G01 X'+cxofs+' Y'+cyofs;

  val(cxofs,xofs,code);
  val(cyofs,yofs,code);
  val(czofs,zofs,code);

  str((xofs-2),uxmin); // Nullpunkte fr Umriss
  str((yofs-2),uymin);

  breit:=bmp.Width;
  hoch:=bmp.Height;

  dbreit:=breit*pixbreit;
  cbreit:=FloatToStrF((dbreit+xofs), ffFixed, 15, 2);         // echte X-Breite in mm (2 Nachkommastellen)
  uxmax:=FloatToStrF((dbreit+xofs+2), ffFixed, 15, 2);        // echte X-Breite in mm +2mm fr Umriss (2 Nachkommastellen)

  dhoch:=hoch*pixhoch;
  choch:=FloatToStrF((dhoch+yofs), ffFixed, 15, 2);           // echte Y-Hhe in mm (2 Nachkommastellen)
  uymax:=FloatToStrF((dhoch+yofs+2), ffFixed, 15, 2);         // echte Y-Hhe in mm + 2mm fr Umriss (2 Nachkommastellen)

  // Umwandeln der Feedrate von mm/Sekunde in mm/Minute
  GVtmp:=Edit10.Text;
  GRtmp:=Edit11.Text;
  GZtmp:=Edit17.Text;
  lein:=Edit12.Text;
  laus:=Edit13.Text;

  defacc:=Edit18.Text;
  maxacc:=Edit19.Text;

  val(GVtmp,GVx,code);
  val(GRtmp,GRx,code);
  val(GZtmp,GZx,code);
  GRx:=GRx*60;
  GVx:=GVx*60;
  GZx:=GZx*60;
  str(GVx,GV);
  str(GRx,GR);
  str(GZx,GZ);

  if RadioGroup2.ItemIndex=0 then
    begin
      zv0:='G01 Z0 F'+GV;
      zv1:='G01 Z0.05 F'+GV;
      zv2:='G01 Z0 F'+GR;
    end;

  if RadioGroup2.ItemIndex=1 then
    begin
      zv0:=laus;
      zv1:=lein;
      zv2:=laus;
    end;

  assignfile(dfi,Edit9.Text);
  rewrite(dfi);

  val(Edit8.Text,XF,code);

  writeln(dfi,'M17  ;Schrittmotoren ein');
  writeln(dfi,'G21  ;Alle Werte in mm');
  writeln(dfi,'G90  ;absolute Positionierung verwenden');
  writeln(dfi,maxacc);
  writeln(dfi,defacc);
  writeln(dfi,nullp);
  writeln(dfi,'');

  if Form1.CheckBox3.checked=true then
     begin
       inistr[1]:=laus;
       inistr[2]:='G28';
       inistr[3]:='G01 Z'+czofs+' F'+GZ;
       inistr[4]:='';
       for xst:=1 to 4 do writeln(dfi,inistr[xst]);
     end;


  // --------- Umriss zeichnen mit 2mm Zuschlag auf jeder Seite ---------- //
  iz:=7;
  if Form1.CheckBox2.checked=true then  iz:=8;
  if Form1.CheckBox1.checked=true then
     begin
       inistr[1]:= 'G01 X'+uxmin+' Y'+uymin+' F'+GV;
       inistr[2]:= lein;
       inistr[3]:= 'G01 X'+uxmax+' Y'+uymin+' F'+GV;
       inistr[4]:= 'G01 X'+uxmax+' Y'+uymax+' F'+GV;
       inistr[5]:= 'G01 X'+uxmin+' Y'+uymax+' F'+GV;
       inistr[6]:= 'G01 X'+uxmin+' Y'+uymin+' F'+GV;
       inistr[7]:= laus;
       inistr[8]:= 'G4 P5000  ; 5 Sekunden Pause';
       for xst:=1 to iz do writeln(dfi,inistr[xst]);
       writeln(dfi,'')
     end;

  vh:='B';
  ZXX:=0;

  image1.Refresh;

  for zy:=1 to hoch do
    begin
      Progressbar1.Position:=zy;
      Application.ProcessMessages;
      zeile:=IntToStr(zy);
      for zx:=1 to breit do
        begin
          clpix:=image1.canvas.Pixels[zx,zy];
          fr:=GetRValue(clpix);
          fg:=GetGValue(clpix);          // RGB Farbwerte des Pixel
          fb:=GetBValue(clpix);

          fsumc:='F';
          // Es wird Kupfer ("K") definiert, wenn einer der RGB-Werte unter die Schaltschwelle kommt (z.B.254)
          // weie Flchen haben (normal) 255/255/255 RGB
          if (fr<XF) or (fg<XF) or (fb<XF) then fsumc:='K';
          inc(ZXX);

          //************* Materialwechsel (Kupfer/Wei) oder Zeilenende *************
          if ((fsumc<>vh) or (zx=breit)) and (vh<>'B') then
             begin

               pospix:=IntToStr(zx);
               pospix:=' *'+pospix+'*';                                     // echte Position in Pixel

               posxmmd:=zx*pixbreit;
               posxmm:=FloatToStrF((posxmmd+xofs), ffFixed, 15, 2);         // echte X Position in mm (2 Nachkommastellen)
               posxmm:=StringReplace(posxmm,',','.',[rfReplaceAll]);
               posymmd:=zy*pixhoch;
               posymm:=FloatToStrF((posymmd+yofs), ffFixed, 15, 2);         // echte Y Position in mm (2 Nachkommastellen)
               posymm:=StringReplace(posymm,',','.',[rfReplaceAll]);        // Aus "Komma" einen "Punkt" machen

               zxxc:=IntToStr(ZXX)+' x '+vh;
               vweg:=ZXX*pixbreit;
               zxxp:=FloatToStrF(vweg, ffFixed, 15, 2);

               if vh='K' then
                   begin
                     belichten:=zv1;
                     writeln(dfi,belichten);
                     belichten:='G01 X'+posxmm+' F'+GV;
                     writeln(dfi,belichten);
                   end;

               if vh='F' then
                   begin
                     belichten:=zv0;
                     writeln(dfi,belichten);
                     belichten:='G01 X'+posxmm+' F'+GV;
                     writeln(dfi,belichten);
                   end;

               ZXX:=0;
               if zx=breit then                              // NC-Ausgabe bei neuer Zeile
                 begin
                   vh:='E';
                   writeln(dfi);
                   rueckfahrt:=zv2+' ;Ruecklauf';                    writeln(dfi,rueckfahrt);
                   rueckfahrt:='G00 X'+cxofs+' F'+GR+' ;Ruecklauf';  writeln(dfi,rueckfahrt);
                   rueckfahrt:='G00 Y'+posymm+' F'+GR+' ;Ruecklauf'; writeln(dfi,rueckfahrt);
                   writeln(dfi);
                 end;
             end;

          vh:=fsumc;
          //writeln(dfi,fsumc);
        end;

    end;

  writeln(dfi,laus);
  writeln(dfi,nullp);
  writeln(dfi,'M18 ;Schrittmotoren aus');
  Application.ProcessMessages;
  imess:=Edit9.Text+' ausgegeben';
  MessageBox(handle,PChar(imess),'Information',0);
  closefile(dfi);
  bmp.free;
  Progressbar1.Position:=0;
  Application.ProcessMessages;
  close;

end;

procedure TForm1.Button3Click(Sender: TObject);
var
  itmp,idat,odat : String;
  x : Integer;

begin
//  BMP auswhlen //
  openDialog1.InitialDir := GetCurrentDir;
  openDialog1.Filter := 'BMP Files (*.bmp)|*.BMP';
  opendialog1.Execute;
  idat:=Opendialog1.filename;
  Form1.Edit3.Text:=idat;
  odat:='';
  for x:=1 to (pos('.',idat)-1) do odat:=odat+idat[x];
  odat:=odat+'.gcode';
  if Edit3.Text='' then Edit9.Text:='PCB-Demo.gcode'
    else Edit9.Text:=odat;
  if Edit3.Text='' then Edit3.Text:='PCB-Demo.bmp'
    else Button1Click(NIL);
  Application.ProcessMessages;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
// Programm beenden  //
  close;
end;


procedure TForm1.Button5Click(Sender: TObject);
// ************* TImage negativ erstellen *************** //
begin
  NegativeBitmapFX(image1.picture.bitmap);
  image1.Refresh;
end;

procedure TForm1.Button6Click(Sender: TObject);
// ************* TImage spiegeln *************** //
begin
  image1.picture.bitmap:= FlipReverseScanLine(true,false,image1.picture.bitmap);
  image1.Refresh;
end;


procedure TForm1.Button7Click(Sender: TObject);
// ************* TImage drehen *************** //
begin
  image1.picture.bitmap:= RotateScanLine90(90,image1.picture.bitmap);
  image1.Refresh;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  tm,stm : String;
  x,code : Integer;
begin
{ ############################################################# }
{ ############################################################# }
{ ########## PCB - BMP in G-Code umwandeln #################### }
{ ############################################################# }
{ ############################################################# }

// ------ INI-Datei einlesen und Edit-Felder fllen ------- //

  Edit8.Text:='';
  Edit10.Text:='';
  Edit11.Text:='';
  Edit12.Text:='';
  Edit13.Text:='';
  Edit14.Text:='';
  Edit15.Text:='';
  Edit16.Text:='';
  Edit17.Text:='';
  Edit18.Text:='';
  Edit19.Text:='';
  xofs:=0; yofs:=0; zofs:=0;

  assignfile(dfini,'Parameter.ini');
  reset(dfini);
  while not Eof(dfini) do
    begin
      readln(dfini,tm);

      if pos('Lasergeschwindigkeit:',tm)>0 then
        begin
          stm:='';
          for x:=(pos(':',tm)+2) to length(tm) do stm:=stm+tm[x];
          Edit10.Text:=stm;
        end;

      if pos('Eilganggeschwindigkeit:',tm)>0 then
        begin
          stm:='';
          for x:=(pos(':',tm)+2) to length(tm) do stm:=stm+tm[x];
          Edit11.Text:=stm;
        end;

      if pos('Z-Geschwindigkeit:',tm)>0 then
        begin
          stm:='';
          for x:=(pos(':',tm)+2) to length(tm) do stm:=stm+tm[x];
          Edit17.Text:=stm;
        end;

      if pos('RGB-Summenfilter:',tm)>0 then
        begin
          stm:='';
          for x:=(pos(':',tm)+2) to length(tm) do stm:=stm+tm[x];
          Edit8.Text:=stm;
        end;

      if pos('Laser-ein Kommando:',tm)>0 then
        begin
          stm:='';
          for x:=(pos(':',tm)+2) to length(tm) do stm:=stm+tm[x];
          Edit12.Text:=stm;
        end;

      if pos('Laser-aus Kommando:',tm)>0 then
        begin
          stm:='';
          for x:=(pos(':',tm)+2) to length(tm) do stm:=stm+tm[x];
          Edit13.Text:=stm;
        end;

      if pos('X-Offset:',tm)>0 then
        begin
          stm:='';
          for x:=(pos(':',tm)+2) to length(tm) do stm:=stm+tm[x];
          Edit15.Text:=stm;
          val(stm,xofs,code);
        end;

      if pos('Y-Offset:',tm)>0 then
        begin
          stm:='';
          for x:=(pos(':',tm)+2) to length(tm) do stm:=stm+tm[x];
          Edit16.Text:=stm;
          val(stm,yofs,code);
        end;

      if pos('Z-Offset:',tm)>0 then
        begin
          stm:='';
          for x:=(pos(':',tm)+2) to length(tm) do stm:=stm+tm[x];
          Edit14.Text:=stm;
          val(stm,zofs,code);
        end;

      if pos('Max Acceleration:',tm)>0 then
        begin
          stm:='';
          for x:=(pos(':',tm)+2) to length(tm) do stm:=stm+tm[x];
          Edit19.Text:=stm;
          val(stm,zofs,code);
        end;

      if pos('Default Acceleration:',tm)>0 then
        begin
          stm:='';
          for x:=(pos(':',tm)+2) to length(tm) do stm:=stm+tm[x];
          Edit18.Text:=stm;
          val(stm,zofs,code);
        end;

    end;
  closefile(dfini);


  geladen:=0;  // Wurde schon ein BMP geladen?
  PStart:=1;   // Um zu verhindern, das bei nachfolgenden setzen der Buttons das "OnClock-Event" ausgefhrt wird!
  RadioGroup1.ItemIndex:=1;
  RadioGroup2.ItemIndex:=1;
  PStart:=0;

  Progressbar1.Min:=0;
  Progressbar1.Max:=1000;

  Form1.CheckBox1.checked:=true;
  Form1.CheckBox2.checked:=true;
  Form1.CheckBox3.checked:=true;

  Edit1.Text:='';
  Edit2.Text:='';
  Edit3.Text:='PCB-Demo.bmp';
  Edit4.Text:='';
  Edit5.Text:='';
  Edit6.Text:='';
  Edit7.Text:='';
  Edit9.Text:='PCB-Demo.gcode';

end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
 // Nur bei "echtem" OnClick und bereits geladenem BMP ausfhren
   if (PStart=0) and (geladen=1) then Button1Click(NIL);
end;

end.

